{Tic Tac Toe by Jay [feelicks] McCarthy}
{ - Has Computer AI}
{ - Has AI vs. AI}
{ - Has Two-Player Support}

{You can contact me via..}
{ email: jay@kenyamountain.com}
{ ICQ: 14301127}
{ AIM: Rasarasda}
{ IRC : feelicks}

uses crt;

var
 win,players,x,y,turn: byte;
 square : array[1..3,1..3] of char;
 chosen : boolean;
 again : char;
 cross, corner : array[1..4] of boolean;

procedure SetVars;
begin
  for x := 1 to 4 do
  begin
   cross[x] := false;
   corner[x] := false;
  end;
 for x := 1 to 3 do
  for y := 1 to 3 do
   square[x,y] := '.';
 win := 0;
 randomize;
 turn := random(2)+1;
 chosen := false;
 again := 'Y';
end;

procedure Drawboard;
begin
 clrscr;
 writeln;
 writeln('Tic Tac Toe');
 writeln(' -Two Player, One Player w/ Opponent AI, and AI vs AI');
 writeln('by Jay [feelicks] McCarthy - jay@kenyamountain.com');
 writeln;
 writeln(square[1,1],'|',square[1,2],'|',square[1,3]);
 writeln('-----');
 writeln(square[2,1],'|',square[2,2],'|',square[2,3]);
 writeln('-----');
 writeln(square[3,1],'|',square[3,2],'|',square[3,3]);
end;

procedure HumanChoice;
begin
 repeat
  write(' x : '); readln(x);
  write(' y : '); readln(y);
 until square[x,y] = '.';
 if turn = 1 then square[x,y] := 'O' else square[x,y] := 'X';
end;

procedure CheckSpot(x1,y1,x2,y2,x3,y3 : byte; symbol:char);
begin
 if chosen = false then
  if square[x1,y1] = symbol then
   if square[x2,y2] = symbol then
    if square[x3,y3] = '.' then
    begin
     x := x3;
     y := y3;
     chosen := true;
    end
end;

procedure CheckAlot(symbol : char);
begin
  {Row 1}
   CheckSpot(1,1,1,2,1,3,symbol);
   CheckSpot(1,2,1,3,1,1,symbol);
   CheckSpot(1,1,1,3,1,2,symbol);
  {Row 2}
   CheckSpot(2,1,2,2,2,3,symbol);
   CheckSpot(2,2,2,3,2,1,symbol);
   CheckSpot(2,1,2,3,2,2,symbol);
  {Row 3}
   CheckSpot(3,1,3,2,3,3,symbol);
   CheckSpot(3,2,3,3,3,1,symbol);
   CheckSpot(3,1,3,3,3,2,symbol);
  {Coloumn 1}
   CheckSpot(1,1,2,1,3,1,symbol);
   CheckSpot(2,1,3,1,1,1,symbol);
   CheckSpot(1,1,3,1,2,1,symbol);
  {Coloumn 2}
   CheckSpot(1,2,2,2,3,2,symbol);
   CheckSpot(2,2,3,2,1,2,symbol);
   CheckSpot(1,2,3,2,2,2,symbol);
  {Coloumn 3}
   CheckSpot(1,3,2,3,3,3,symbol);
   CheckSpot(2,3,3,3,1,3,symbol);
   CheckSpot(1,3,3,3,2,3,symbol);
  {Diagonal R-L}
   CheckSpot(1,1,2,2,3,3,symbol);
   CheckSpot(2,2,3,3,1,1,symbol);
   CheckSpot(1,1,3,3,2,2,symbol);
  {Diagonal L-R}
   CheckSpot(1,3,2,2,3,1,symbol);
   CheckSpot(2,2,3,1,1,3,symbol);
   CheckSpot(1,3,3,1,2,2,symbol);
end;

procedure CheckMid;
begin
 if chosen = false then
  if square[2,2] = '.' then
  begin
   x := 2;
   y := 2;
   chosen := true;
  end
end;

procedure CheckCorners;
var corn : byte; 
begin
 repeat
  randomize;
  corn := random(4)+1;
  case corn of
   1: 
   begin
    x := 1; 
    y := 1; 
   end;
   2:
   begin
    x := 1; 
    y := 3; 
   end;
   3:
   begin
    x := 3; 
    y := 1; 
   end;
   4:
   begin
    x := 3; 
    y := 3;
   end;
  end;
  if square[x,y] <> '.' then corner[corn] := true else chosen := true;
 until (corner[1] = true) and (corner[2] = true) and (corner[3] = true) and (corner[4] = true) or (chosen = true)
end;

procedure CheckCross;
var cros : byte;
begin
 repeat
  randomize;
  cros := random(4)+1;
  case cros of
   1:
   begin
    x := 1; 
    y := 2; 
   end;
   2:
   begin
    x := 2; 
    y := 1; 
   end;
   3:
   begin
    x := 2; 
    y := 3; 
   end;
   4:
   begin
    x := 3; 
    y := 2; 
   end;
  end;
  if square[x,y] <> '.' then cross[cros] := true else chosen := true;
 until (cross[1] = true) and (cross[2] = true) and (cross[3] = true) and (cross[4] = true) or (chosen = true)
end;

procedure ComputerChoice;
var cc : byte;
    me,en : char;
begin
 case turn of
  1:
  begin
   me := 'O';
   en := 'X';
  end;
  2:
  begin
   me := 'X';
   en := 'O';
  end;
 end;
 repeat
 {First Check to win..}
 if chosen = false then CheckAlot(me);
 {Then check to block..}
 if chosen = false then CheckAlot(en);
 {Check middle square for vacany..}
 if chosen = false then CheckMid;
 {Randomly choose whether to check corners or cross}
 randomize;
 cc := random(2)+1;
 {Check corners for vacany..}
 if (corner[1] <> true) and (corner[2] <> true) and (corner[3] <> true) and (corner[4] <> true) then
  if (cc = 1) and (chosen = false) then CheckCorners;
 {Check cross for vacany..}
 if (cross[1] <> true) and (cross[2] <> true) and (cross[3] <> true) and (cross[4] <> true) then
  if (cc = 2) and (chosen = false) then CheckCross;
 {By now every square has been checked!}
 until square[x,y] = '.';
 if chosen = true then
 begin
  square[x,y] := me;
  chosen := false;
 end
end;

procedure PromptPlayer;
begin
 x := 0;
 y := 0;
 writeln;
 if turn = 1 then turn := 2 else turn := 1;
 writeln('Player ',turn,' please choose a square');
 if players = 0 then ComputerChoice else
  if (players = 1) and (turn = 2) then ComputerChoice else HumanChoice;
end;

procedure CheckForWin(symbol : char; winner : byte);
begin
 {Rows}
 if (square[1,1] = symbol) and (square[1,2] = symbol) and (square[1,3] = symbol) then win := winner;
 if (square[2,1] = symbol) and (square[2,2] = symbol) and (square[2,3] = symbol) then win := winner;
 if (square[3,1] = symbol) and (square[3,2] = symbol) and (square[3,3] = symbol) then win := winner;
 {Coloumns}
 if (square[1,1] = symbol) and (square[2,1] = symbol) and (square[3,1] = symbol) then win := winner;
 if (square[1,2] = symbol) and (square[2,2] = symbol) and (square[3,2] = symbol) then win := winner;
 if (square[1,3] = symbol) and (square[2,3] = symbol) and (square[3,3] = symbol) then win := winner;
 {Diagonals}
 if (square[1,1] = symbol) and (square[2,2] = symbol) and (square[3,3] = symbol) then win := winner;
 if (square[1,3] = symbol) and (square[2,2] = symbol) and (square[3,1] = symbol) then win := winner;
end;

procedure CheckForTie;
var empty : byte;
begin
 empty := 0;
 for x := 1 to 3 do
  for y := 1 to 3 do
   if square[x,y] = '.' then empty := empty + 1;
 if empty = 0 then win := 3;
end;

procedure AnnounceWinner;
begin
 writeln;
 case win of
  1: writeln('Player One Wins!!');
  2: writeln('Player Two Wins!!');
  3: writeln('Darn! A Tie!');
 end;
end;

procedure PlayAgain;
begin
 writeln;
 writeln('Would you like to play again? [Y/N]');
 write('>'); readln(again);
end;

begin
repeat
 SetVars;
 clrscr;
 writeln;
 writeln('Tic Tac Toe');
 writeln(' -Two Player, One Player w/ Opponent AI, and AI vs AI');
 writeln('by Jay [feelicks] McCarthy - jay@kenyamountain.com');
 writeln;
 writeln('How many players? [0/1/2]');
 write('>'); readln(players); 
 repeat
  Drawboard;
  PromptPlayer;
  CheckForWin('O',1);
  CheckForWIn('X',2);
  CheckForTie;
  Drawboard;
 until win <> 0;
 AnnounceWinner;
 PlayAgain;
until upcase(again) = 'N';
end.